/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *    http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
// demo.cpp : ̨Ӧóڵ㡣
//
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

#include "CCPRestClient.h"
int _tmain(int argc, _TCHAR* argv[])
{
	//־
	setLogLevel(LOG_PACKAGE);

	//ʼ 
	char *pRestIP="app.cloopen.com";//app.cloopen.com,Ҫдhttps//
	int port=8883;//htts 8883
	init(pRestIP, port);

	//˺ ˺֤
	char *pAccount="AccountSid";
	char *pAccountToken="AccountToken ";
	setAccount(pAccount,pAccountToken);
	
	//˻Ϣѯ
	AccountInfo p;
	memset(&p,0,sizeof(AccountInfo));
	int ret=queryAccountInfo(&p);

	//ӡ
	printf("ret=%d\r\n",ret);
	printf("statusCode=%d\r\n",p.reason.statusCode);
	printf("statusMsg=%s\r\n",p.reason.statusMsg);
	printf("dateCreated=%s\r\n",p.dateCreated);
	printf("dateUpdated=%s\r\n",p.dateUpdated);
	printf("friendlyName=%s\r\n",p.friendlyName);
	printf("type=%d\r\n",p.type);
	printf("status=%d\r\n",p.status);
	printf("balance=%lf\r\n",p.balance);
	printf("subBalance=%lf\r\n",p.subBalance);

	//ʼ
	unInit();

	return 0;
}

