/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
/*<time.h> by yangyang
// tm˵
//struct tm {
//        int tm_sec;     /*  C ȡֵΪ[0,59] */
//        int tm_min;     /*  - ȡֵΪ[0,59] */
//        int tm_hour;    /* ʱ - ȡֵΪ[0,23] */
//        int tm_mday;    /* һе - ȡֵΪ[1,31] */
//        int tm_mon;     /* ·ݣһ¿ʼ0һ£ - ȡֵΪ[0,11] */
//        int tm_year;    /* ݣֵʵݼȥ1900 */
//        int tm_wday;    /*  C ȡֵΪ[0,6]0죬1һԴ */
//        int tm_yday;    /* ÿ11տʼ C ȡֵΪ[0,365]011գ112գԴ */
//        int tm_isdst;   /* ʱʶʵʱʱtm_isdstΪʵʱĽtm_isdstΪ0˽ʱtm_isdst()Ϊ*/
//        };
//#define _TM_DEFINED

// time_t˵/
//typedef long time_t;         /* ʱֵ */

/*
ʹGetLocalTime()GetSystemTime()õʱ䲻ͬ

void getsystemtime(
lpsystemtime lpsystemtime // system time
);
void getlocaltime(
lpsystemtime lpsystemtime // system time
);
typedef struct _systemtime {
word wyear;
word wmonth;
word wdayofweek;
word wday;
word whour;
word wminute;
word wsecond;
word wmilliseconds;
} systemtime, *psystemtime;*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "common.h"

#if _MY_WINDOWS_
#include <io.h> 
#include <direct.h> 
#elif _MY_LINUX64_
#include <sys/stat.h>
#include <locale.h>
#include <stdlib.h>
#endif

int GetNowWeek() //[1..7]
{
	struct tm *local;
	time_t nowdate;
	int week=0;
	nowdate=time(NULL);
	local=localtime(&nowdate);
	week=local->tm_wday+1;	
	return week;
}

int GetNowTime() //صǰʱ   UTC->Local
{
	struct tm *local;
	time_t nowdate;
	int timeint=0;
	nowdate=time(NULL);
	local=localtime(&nowdate);
	timeint=local->tm_hour*60*60+local->tm_min*60+local->tm_sec;
	
	return timeint;	
}

int	GetSetTime(time_t setTime) //趨ʱ    UTC->Local
{
	struct tm *local;
	int timeint=0;
	local=localtime(&setTime);
	timeint=local->tm_hour*60*60+local->tm_min*60+local->tm_sec;
	
	return timeint;	
}


// Ҫַʱ
/*
%a ڼļд 
%A ڼȫ 
%b ·ֵļд 
%B ·ݵȫ 
%c ׼ڵʱ䴮 
%C ݵĺλ 
%d ʮƱʾÿµĵڼ 
%D // 
%e ַУʮƱʾÿµĵڼ 
%F -- 
%g ݵĺλ֣ʹûܵ 
%G ֣ʹûܵ 
%h д· 
%H 24СʱƵСʱ 
%I 12СʱƵСʱ
%j ʮƱʾÿĵڼ 
%m ʮƱʾ· 
%M ʮʱƱʾķ 
%n з 
%p صAMPMĵȼʾ 
%r 12Сʱʱ 
%R ʾСʱͷӣhh:mm 
%S ʮƵ 
%t ˮƽƱ 
%T ʾʱ룺hh:mm:ss 
%u ÿܵĵڼ죬һΪһ ֵ06һΪ0
%U ĵڼܣΪһ죨ֵ053
%V ÿĵڼܣʹûܵ 
%w ʮƱʾڼֵ06Ϊ0
%W ÿĵڼܣһΪһ죨ֵ053 
%x ׼ڴ 
%X ׼ʱ䴮 
%y ͵ʮݣֵ099
%Y Ͳֵʮ 
%z%Z ʱƣܵõʱ򷵻ؿַ
%% ٷֺ

*/
//
time_t FormatNowDate(char* format,char* dest,int Maxsize) //UTC
{
	struct tm *local;
	time_t nowdate;
	nowdate=time(NULL);
	local=localtime(&nowdate);
	strftime(dest,Maxsize,format,local);	

	return mktime(local);
}

void FormatSetDate(char* format,time_t Datetime,char* dest,int Maxsize)
{
	struct tm *local;
	local=localtime(&(Datetime));
	strftime(dest,Maxsize,format,local);	
}

/************************************************************************/
/*   غ ǰʱ                                                                   */
/************************************************************************/
uIn64 GetMillisecondTimeLong(TIMEVAL8* out_time)
{
#if _MY_WINDOWS_
	struct _timeb  y_time;
	_ftime(   &y_time   ); 
#elif _MY_LINUX64_
        struct timeb  y_time;
        ftime(&y_time);
#endif
	if(out_time!=NULL)
	{
		out_time->tv_sec = y_time.time;
		out_time->tv_usec= y_time.millitm*1000;
	}

	return ((uIn64)y_time.time*1000) + y_time.millitm;
}

/************************************************************************/
/*	صǰʱַʽ                                                                     */
/************************************************************************/
#if _MY_WINDOWS_
__inline void GetMillisecondTimeFmt(char* _out_date)
{
	SYSTEMTIME systime;
	//GetSystemTime(&systime);//ϵͳʱ
	GetLocalTime(&systime);
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d%03d"
						,systime.wYear
						,systime.wMonth
						,systime.wDay
						,systime.wHour
						,systime.wMinute
						,systime.wSecond
						,systime.wMilliseconds);
#elif _MY_LINUX64_
void GetMillisecondTimeFmt(char* _out_date)
{
   struct tm* systime;
   time_t t;
   t=time(NULL);                
	//systime=gmtime(&t);//׼ʱ
	systime=localtime(&t);//localtime() йõıʱ׼ʱ8Сʱ
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d%3d"
						,systime->tm_year
						,systime->tm_mon
						,systime->tm_mday
						,systime->tm_hour
						,systime->tm_min
						,systime->tm_sec
						,0
                                                ); 
#endif
}

#if _MY_WINDOWS_
__inline void GetGetSecondTimeFmt_yyyyMMddHHmmss(char* _out_date)
{
	SYSTEMTIME systime;
	//GetSystemTime(&systime);//ϵͳʱ
	GetLocalTime(&systime);
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d"
						,systime.wYear
						,systime.wMonth
						,systime.wDay
						,systime.wHour
						,systime.wMinute
						,systime.wSecond);
#elif _MY_LINUX64_
void GetGetSecondTimeFmt_yyyyMMddHHmmss(char* _out_date)
{
   struct tm* systime;
   time_t t;
   t=time(NULL);                
	//systime=gmtime(&t);//׼ʱ
	systime=localtime(&t);//localtime() йõıʱ׼ʱ8Сʱ
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d"
						,systime->tm_year
						,systime->tm_mon
						,systime->tm_mday
						,systime->tm_hour
						,systime->tm_min
						,systime->tm_sec); 
#endif
}


#if _MY_WINDOWS_
__inline void GetMillisecondTimeFmt_TIME(char* _out_date)
{
	SYSTEMTIME systime;

	//GetSystemTime(&systime);//ϵͳʱ
	GetLocalTime(&systime);

	sprintf(_out_date,"%02d%02d%02d"
		,systime.wHour
		,systime.wMinute
		,systime.wSecond);
}
#elif _MY_LINUX64_
void GetMillisecondTimeFmt_TIME(char* _out_date)
{
struct tm* systime;
   time_t t;
   t=time(NULL);                
	//systime=gmtime(&t);//׼ʱ
	systime=localtime(&t);//localtime() йõıʱ׼ʱ8Сʱ
	sprintf(_out_date,"%02d%02d%02d"
						,systime->tm_hour
						,systime->tm_min
						,systime->tm_sec
						); 
}
#endif

#if _MY_WINDOWS_
__inline void GetSecondTimeFmt_yyyyMMddHHmmss(char* _out_date)
{
	SYSTEMTIME systime;
	//GetSystemTime(&systime);//ϵͳʱ
	GetLocalTime(&systime);
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d"
						,systime.wYear
						,systime.wMonth
						,systime.wDay
						,systime.wHour
						,systime.wMinute
						,systime.wSecond);
#elif _MY_LINUX64_
void etSecondTimeFmt_yyyyMMddHHmmss(char* _out_date)
{
   struct tm* systime;
   time_t t;
   t=time(NULL);                
	//systime=gmtime(&t);//׼ʱ
	systime=localtime(&t);//localtime() йõıʱ׼ʱ8Сʱ
	sprintf(_out_date,"%04d%02d%02d%02d%02d%02d"
						,systime->tm_year
						,systime->tm_mon
						,systime->tm_mday
						,systime->tm_hour
						,systime->tm_min
						,systime->tm_sec); 
#endif
}



uIn64 my_str_2_int64(char* data)
{
#if _MY_WINDOWS_
	return _atoi64(data);
#elif _MY_LINUX64_
	return atoll(data);
#endif
}

int is_match_ip(uChar* ip1,uChar* ip2)
{
	int i = 3;
	while(i>=0)
	{
		if(ip1[i] != ip2[i])
			return 0;
		i--;
	}

	return 1;
}

inline int is_match_ip_com(CHAR_IP* QQserverIPs,int size, uChar* arrayIps)
{
	for(int i=0;i<size;i++)
	{
		if(QQserverIPs[i].ntype == 0) return 1;

		if(QQserverIPs[i].ntype == 4)
		{
			if(QQserverIPs[i].ip[0]==arrayIps[0] 
			&& QQserverIPs[i].ip[1]==arrayIps[1] 
			&& QQserverIPs[i].ip[2]==arrayIps[2]
			&& QQserverIPs[i].ip[3]==arrayIps[3] )
				return 1;

		}
		else
			if(QQserverIPs[i].ntype == 3)
			{
				if(QQserverIPs[i].ip[0]==arrayIps[0] 
				&& QQserverIPs[i].ip[1]==arrayIps[1] 
				&& QQserverIPs[i].ip[2]==arrayIps[2])
					return 1;
			}
	}

	return 0;
}


uIn16 my_ntohs(uIn16 netShort)
{
#if _MY_WINDOWS_
	return ntohs(netShort);
#elif _MY_LINUX64_
	return (((netShort & 0xFF00) >> 8) |  ((netShort & 0x00FF) << 8));
#endif
}

uIn32 my_ntohl32(uIn32 netInt)
{
#if _MY_WINDOWS_
	return ntohl(netInt);
#elif _MY_LINUX64_
	return (((netInt & 0xFF000000) >> 24) |  ((netInt & 0x00FF0000) >> 8) | ((netInt & 0x0000FF00) << 8) |  ((netInt & 0x000000FF) << 24));
#endif
}

//void Debug_print_hex(char* pData, int length)
//{
//	ERROR_PRINT("Hex Data:\n\t");
//	for(int i=0;i<length ; i++ )
//	{
//			ERROR_PRINT("0x%02x ",(uChar)pData[i]);	
//			if(i % 16 == 0)
//				ERROR_PRINT("\n\t");
//	}
//	ERROR_PRINT("\n");
//}

//
int unicode_to_utf8(char* szUnicode,char* dest,int dst_len) 
{ 

	int wcsLen = ::MultiByteToWideChar(CP_ACP, NULL, szUnicode, strlen(szUnicode), NULL, 0); 
	//ռҪ'\0'ռ䣬MultiByteToWideChar'\0'ռ 
	// wcsLen һҪstrlen(szUnicode)Ŀռ21Ŀdst_lenҲҪ21
	
	//wchar_t* wszString = new wchar_t[wcsLen + 1]; 
	wchar_t wszString[5120];
	if(wcsLen + 1>5120 )
		return -1;
	//ת 
	::MultiByteToWideChar(CP_ACP, NULL, szUnicode, strlen(szUnicode), wszString, wcsLen); 
	//'\0' 
	wszString[wcsLen] = '\0'; 
	//unicodeMessageBox API 


	int ansiLen = ::WideCharToMultiByte(CP_UTF8, NULL, wszString, wcslen(wszString), NULL, 0, NULL, NULL); 
	//ͬϣռҪ'\0'ռ 

	if(ansiLen+1 >dst_len)
	{
		//return -2;
	    return -(ansiLen+1);
	}
	//char* szAnsi = new char[ansiLen + 1]; 
	//ת 
	//unicodeӦstrlenwcslen 
	::WideCharToMultiByte(CP_UTF8, NULL, wszString, wcslen(wszString), dest, ansiLen, NULL, NULL); 
	//'\0' 
	dest[ansiLen] = '\0'; 
	//AnsiMessageBox API 
	//printf("c:%s\n",szAnsi);
	return ansiLen;
	//дıͬansi to unicode 
} 
#if _MY_WINDOWS_
int utf8_to_unicode(char* szU8,char* dest,int dst_len) 
{ 
	//UTF8 to Unicode 
	//ֱӸƹ룬ʱᱨʲ16ʽ 

	//char szU8[128] ={ 0x1f,0x0f ,0xea ,0x7f ,0xe4 ,0xb8 ,0xa4 ,0xe4 ,0xb8 ,0xaa ,0xe6 ,0x9c ,0x88 ,0xe4 ,0xba ,0xae ,0x00};
	//char* szU8 = "abcd1234\xe4\xbd\xa0\xe6\x88\x91\xe4\xbb\x96\x00"; 
	//char* szU8_2 = "abcd1234"; 
	//ԤתõռĴС 
	int wcsLen = ::MultiByteToWideChar(CP_UTF8, NULL, szU8, strlen(szU8), NULL, 0); 
	//ռҪ'\0'ռ䣬MultiByteToWideChar'\0'ռ 
	//wchar_t* wszString = new wchar_t[wcsLen + 1]; 
	wchar_t wszString[5120];
	if(wcsLen + 1>5120 )
		return -1;
	//ת 
	::MultiByteToWideChar(CP_UTF8, NULL, szU8, strlen(szU8), wszString, wcsLen); 
	//'\0' 
	wszString[wcsLen] = '\0'; 
	//unicodeMessageBox API 


	int ansiLen = ::WideCharToMultiByte(CP_ACP, NULL, wszString, wcslen(wszString), NULL, 0, NULL, NULL); 
	//ͬϣռҪ'\0'ռ 

	if(ansiLen+1 >dst_len)
		return -1;

	//char* szAnsi = new char[ansiLen + 1]; 
	//ת 
	//unicodeӦstrlenwcslen 
	::WideCharToMultiByte(CP_ACP, NULL, wszString, wcslen(wszString), dest, ansiLen, NULL, NULL); 
	//'\0' 
	dest[ansiLen] = '\0'; 
	//AnsiMessageBox API 
	//printf("c:%s\n",szAnsi);
	return ansiLen;
	//дıͬansi to unicode 
} 
#elif _MY_LINUX64_
int utf8_to_unicode(char* szU8,char* dest,int dst_len) 
{
//linux 
int ansiLen=-1;    
// try{
  setlocale(LC_ALL,"zh_CN.GB18030");// locale 
  int wcsLen = mbstowcs(NULL,szU8,0);
  wchar_t wszString[2048];
  if(wcsLen + 1>2048 )
		return -1; 
  mbstowcs(wszString,szU8,wcsLen+1);
  wszString[wcsLen] = 0; 

  setlocale(LC_ALL,"zh_CN.utf8");
  ansiLen =wcstombs(NULL,wszString,0);
  if(ansiLen+1 >dst_len)
		return -1;
  wcstombs(dest,wszString,ansiLen); 
  dest[ansiLen] = '\0';  
//}
/*catch()
{
printf("쳣");
}*/
//finally:{
 setlocale(LC_ALL,"zh_CN.GB18030");// locale   
//} 
  return ansiLen;
}
#endif


/************************************************************************/
/*           ΢                                                           */
/************************************************************************/
void my_sleep(DWORD uSec)
{
#if _MY_WINDOWS_
	DWORD sec = uSec / 1000;//	
	Sleep(sec);//
#elif _MY_LINUX64_
	usleep(uSec);
#endif
}

#if _MY_WINDOWS_
int yy_check_and_mkdirs(char* path)
{
	if( (_access( path, 0 )) != -1 )
		return 1;

	char temp[256] = {0};
	strcat(temp,path);
	int len = strlen(temp);
	while(len>=2){
		if(temp[len-1]=='\\')
		{
			temp[len-1] = '\0';
			break;
		}

		len--;
	}

	if(len<2)
		return 0;

	if(yy_check_and_mkdirs(temp))
	{
		printf("make dir: %s \n",temp);
		_mkdir(path);
		return 1;
	}

	return 0;
}
#elif _MY_LINUX64_
int yy_check_and_mkdirs(char* path)
{
    if((access(path,F_OK)) != -1 )
		return 1;

	char temp[256] = {0};
	strcat(temp,path);
	int len = strlen(temp);

       while(len>=1){
		if(temp[len-1]=='/')
		{
			temp[len-1] = '\0';
			break;
		}

		len--;
	}
	if(len<1)
		return 0;

	if(yy_check_and_mkdirs(temp))
	{
		printf("make dir: %s \n",temp);
                mkdir(path,0777);
		return 1;
	}

	return 0;
}
#endif

#if _MY_WINDOWS_
void getNameFromDirName(char* name,char* dir,int maxlen)
{
	int len = strlen(dir);
	while(len>2)
	{
		if(dir[len-1] == '\\')
		{
			strncpy(name,dir+len,maxlen);
			break;
		}
		len--;
	}
}
#elif _MY_LINUX64_
void getNameFromDirName(char* name,char* dir,int maxlen)
{
	int len = strlen(dir);
	while(len>2)
	{
		if(dir[len-1] == '/')
		{
			strncpy(name,dir+len,maxlen);
			break;
		}
		len--;
	}
}
#endif
//ļչ
void getExtensionNameFromDirName(char* name,char* dir,int maxlen)
{
	int len = strlen(dir);
	while(len>2)
	{
		if(dir[len-1] == '.')
		{
			strncpy(name,dir+len,maxlen);
			break;
		}
		len--;
	}
}
//Ӧó
HANDLE CreateYYThread(void* param, threadProc proc,int level)
{
	HANDLE     hThread;     
	unsigned int   dwThreadID;  
#if _MY_WINDOWS_
	hThread = (HANDLE)_beginthreadex(NULL,0,proc,(LPVOID)param,CREATE_SUSPENDED,&dwThreadID);
	if(hThread==NULL)
	{
	/*	ERROR_PRINT("create thread error code: %d\n",GetLastError());
        if(CIMAPlusCardManager::ms_pInstance->m_bIMAPlusCardLog>=LOG_ERROR)
	    {
	       CLog::OutPut("create thread error code: %d\n",GetLastError());
	    }*/
		return hThread;
	}
	//CIMAPlusCardManager::ms_pInstance->threadHandle[CIMAPlusCardManager::ms_pInstance->waitNumber++] = hThread ;
	SetThreadPriority(hThread,level);
	ResumeThread(hThread);
#else
	struct sched_param schparam;
	pthread_attr_t attr;
	int err = pthread_attr_init(&attr);
	if(err != 0) return NULL;			
	//߳ȼ
	pthread_attr_setschedpolicy(&attr, SCHED_RR);
	schparam.sched_priority = level;
	pthread_attr_setschedparam(&attr,&schparam);

	//߳
	pthread_create((pthread_t*)&hThread,&attr,proc,param);	
	//CIMAPlusCardManager::ms_pInstance->threadHandle[CIMAPlusCardManager::ms_pInstance->waitNumber++] = hThread ;
	pthread_attr_destroy( &attr ); 
#endif

	return hThread;
}

