/*
 *  Copyright (c) 2014 The CCP project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a Beijing Speedtong Information Technology Co.,Ltd license
 *  that can be found in the LICENSE file in the root of the web site.
 *
 *   http://www.yuntongxun.com
 *
 *  An additional intellectual property rights grant can be found
 *  in the file PATENTS.  All contributing project authors may
 *  be found in the AUTHORS file in the root of the source tree.
 */
#ifndef _CCP_REST_DEFINE_H
#define _CCP_REST_DEFINE_H

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//rest ԭ
typedef struct _RestReason
{
	int statusCode;     //ԭ
	char statusMsg[256];//ԭ
}RestReason;

//˻Ϣѯ
typedef struct _AccountInfo
{
	RestReason reason;

	char  dateCreated[20]; //˻Ĵʱ
	char  dateUpdated[20]; //˻Ĵʱ
	char  friendlyName[65];//˻ƣΨһ64ӢĸͰɣĬΪĵַ
	int   type;            //˻ͣȡֵ0ã1עᣩĬֵΪ0
	int   status;          //˻״̬ȡֵ0δ12ͣ3رգĬֵΪ0
	double balance;        //˻

}AccountInfo;

//˺Ϣ
typedef struct _SubAccountInfo
{
	char subAccountSid[33];//˻Id32ӢĸͰɵ˻Ψһʶ
	char subToken[33];     //˻Ȩơ32ӢĸͰ
	char voipAccount[33];  //ͨѶ롣14λ
	char voipPwd[33];      //ͨѶ롣8λֺĸ
	char dateCreated[20];  //˻Ĵʱ
	char friendlyName[65]; //˻ƣΨһ64ӢĸͰɣĬΪĵַ
}SubAccountInfo;
//˺ ˺Ϣѯ
typedef struct _SubAccountOne
{
	RestReason     reason;
	SubAccountInfo SubAccount;
}SubAccountOne;
//ȡ˺ 
typedef struct _SubAccounts
{
	RestReason      reason;
	int             count;//ʵ˻
	SubAccountInfo* SubAccounts;//˻ָ
}SubAccounts;


//˫غ ֪ͨ ֤
typedef struct _CallInfo
{
	RestReason reason;

	char dateCreated[20]; //绰Ĵʱ
	char callSid[33];//һ32ַɵΨһ绰ʶ
}CallInfo;

//Ͷ ģ
typedef struct _SMSInfo
{
	RestReason reason;

	char dateCreated[20]; //ŵĴʱ
	char smsMessageSid[33];//űʶһ32ַɵĶΨһʶ 
}SMSInfo;

//
typedef struct _BillRecord
{
	RestReason reason;

	char downurl[512];//صַ
	char token[128];  //ļؼ 
}BillRecord;

//IVR
typedef struct _IVRCall
{
	RestReason reason;

	char callSid[33];//һ32ַɵΨһ绰ʶ
}IVRCall;

#endif 